[CentOS-devel] How to handle kABI when patching kernel

Ned Slider ned at unixmail.co.uk
Wed Apr 18 18:33:17 EDT 2012


On 18/04/12 07:44, Mike Schmidt wrote:
> Hi,
>
> I've generated (via rpmbuild) a patched version of the latest CentoS 6.2
> kernel (2.6.32-220.7.1)  with the imq patchset (
> http://www.linuximq.net/patches.html), but this causes the kABI to break.
> What can orshould I do about this, if anything?

That all depends on whether a consistent kABI is important to you on 
your system. It might be perfectly acceptable to you to just build your 
new patched kernel and use it.

> What kinds of changes cause the kABI to break? Would it be reasonable to
> think I might be able to fix the patch to be kABI compliant?

Typically changes to whitelisted kernel interfaces (kernel symbols) 
could break the kABI.

It is possible. It really depends what broke and why.

> Is the kABI for CentOS the same as the one for the upstream RHEL version?

Yes.

> Should I try to patch the kABI (as Oracle does in their unbreakable linux
> kernel)? What would be the procedure foir this?
>

Again, that depends (see above). You may be able to work around the 
breakages. The first step is to identify which whitelisted interfaces 
are affected.

> I understand you can't help me with the patches or the kernel itself, but I
> was hoping you might help me understand the kABI well enough that I can
> handle things for there.
>
> Thanks very much.
>

In addition to the reference material posted by Akemi, please also see 
the docs here:

http://people.redhat.com/jcm/el6/dup/docs/

Hope that helps.



More information about the CentOS-devel mailing list